_provider_cache = {}


def provider_factory(variant, payment=None):
    if not payment:
        raise KeyError("Could not configure payment provider without a payment.")

    cache_key = (variant, payment.group.client.pk)

    if cache_key in _provider_cache:
        return _provider_cache[cache_key]

    variant = payment.get_variant()
    provider = variant.get_provider() if variant else None

    if provider is None:
        raise KeyError("Provider not found or not configured for client.")

    _provider_cache[cache_key] = provider
    return provider
